/*
 *                 Copyright (c) Apr 12 19:44:21  MTCC
 *	Author: Michael Thomas
 *	Module: config.h
 *	Created: Sat Apr 12 19:44:21 1997
 *	Abstract:
 *	   various global configuration items for libht
 */

/* Edit History: 
 */


#ifndef h_config
#define h_config

#include "os.h"


/*
 * debugger support
 */

/* where your root is (same as in httpd.conf)
 * note: the debugger will try to educe it's
 * root via DOCUMENT_ROOT, so this is not
 * normally needed.
 */
#define DEBUGCGI   "/debug"      /* URL of debugger code */
#define DEBUGHTML  "/debughtml"  /* URL of debugger html and java */
#define SHELL      "/bin/sh"    /* shell to call */

/* these defines deal include differences. Currently, missing
 * includes will just result in complaints by the compiler
 */


#ifdef LINUX

/* Linux is really smart 'n stuff. it knows about everything. */

#define HAVESTDARG
#define HAVESTDLIB
#define HAVEUNISTD

#endif


#ifdef MIPS

#define HAVESTDARG
#define WANTMALLOCDEFS
#undef HAVESTDLIB
#define HAVEUNISTD
#define NOCONST
#define NOINLINE
#undef  NOELLIPSE
#define WANTSTRDUP
#define WANTSTRERROR
#define WANTSYS_ERRLIST
#define WANTSETSID
#define WANTERRNO
#define WANTSNPRINTF

int printf ();                  /* missing in action; presumed dead. */
char * crypt ();                /* stupid mips unistd doesn't have crypt() */

#endif

#ifdef SUNOS4
#define HAVEMALLOCH
int printf ();
#define setenv putenv
#define WANTSTRERROR
#define WANTSYS_ERRLIST
#define WANTSNPRINTF
#endif


/* ------------------------------------------------------------------------*/
/* shouldn't need to diddle beyond here... */
/* provide strlower */
#define strlower(s) {char * p; for(p=s; *p; p++) if (isupper(*p)) *p=tolower(*p);}
/* compiler bogostities */

#ifdef NOCONST
#define const
#endif
#ifdef NOINLINE
#define inline
#endif

#ifdef NOELLIPSE
#define ELLIPSE void * args
#else
#define ELLIPSE ...
#endif

/*
 * includes required over most of the packages.
 */

#include <stdio.h>              /* fairly uncontroversial */
#include <string.h>             /* ditto */
#include <ctype.h>              /* ditto */
#include <errno.h>              /* ditto, except for errno braindamage */
#include <sys/types.h>          /* not as sure about this one... */

#ifdef HAVESTDARG
#include <stdarg.h>
#define VA_START(var, last) va_start(var, last)
#else
#include <varargs.h>
#define VA_START(var, last) va_start(var)
#endif

#ifdef HAVESTDLIB
#include <stdlib.h>
#else
char * getenv ();

#endif

#ifdef HAVEUNISTD
#include <unistd.h>
#else
char * crypt ();
#endif

#ifdef HAVEMALLOCH
#include <malloc.h>
#endif

#ifdef WANTMALLOCDEFS
void * malloc ();
void * calloc ();
void * realloc ();
void * alloca ();
#endif

#ifdef WANTSTRDUP
#define strdup(s) (strcpy(malloc (strlen(s)+1), s))
#endif

#ifdef WANTSYS_ERRLIST
extern char * sys_errlist [];
#endif
#ifdef WANTSTRERROR
#define strerror(err) (sys_errlist[(err)])
#endif

#ifdef WANTERRNO
extern int errno;               /* some errno.h's don't define errno; pretty lame */
#endif

#ifdef WANTSETSID
#define setsid() (setpgrp(0, 0))
#endif


#ifdef WANTMSQL
#include <msql.h>
#endif

#ifdef WANTDBM
#include <dbm.h>
#endif


#if LOGINTYPE == 0
#define LOGINDB "cgilogin"
#define LOGINDBTABLE "login"
#endif

#if LOGINTYPE == 1
#define LOGINDBFILE "/usr/local/lib/cgilogin"
#endif



#endif /* h_config */
