import java.applet.*;
import java.awt.*;
import java.io.*;
import java.lang.*;
import java.net.*;

public class cgidbg extends Applet implements Runnable
{
    TerminalBox outbox;
    Panel buttonpan;
    Thread t;
    
//    TerminalBox browser;
    TextField inbox;
    Socket s = null, b = null;
    InputStream in;
    DataOutputStream out;
    String lastline = "";
    
    
    
    public void init () 
    {
        String host;
        int port;

        // connect up to the debug front end on the remote side
        try {
            port = Integer.parseInt (getParameter ("dbgport"));
            host = getParameter ("host");
        } catch (Exception e) {
            System.out.println ("host or port not specified");
            return;
        }        
        try {
            s = new Socket (host, port);
            in = s.getInputStream ();
            out = new DataOutputStream (s.getOutputStream ());
            outbox = new TerminalBox (in, 20, 80, 200);            
        } catch (IOException e) {
            System.out.println ("can't open socket to "+host+":"+port);
            return;
        } 
        inbox = new TextField (80);
        add (outbox);
        add (inbox);
        buttonpan = new Panel ();
        buttonpan.add (new Button ("Run"));        
        buttonpan.add (new Button ("Interrupt"));        
        buttonpan.add (new Button ("Kill"));
        buttonpan.add (new Button ("Calls"));
        add (buttonpan);
    }
    
    public void paint (Graphics g) 
    {

    }
    public void start () 
    {
        if (outbox != null)
            outbox.start ();
        t = new Thread (this);
        t.start ();
    }
    
    public void stop () 
    {
        if (outbox != null)
            outbox.stop ();
        t.stop ();
    }
    
    public void  run () 
    {
        Dimension d;
        d  = outbox.size ();
        setBackground (Color.white);
        System.out.println ("term: "+ d.toString());
        d.height = inbox.size ().height;
        System.out.println ("in: "+ d.toString());
        inbox.resize (d);
        d.height = buttonpan.size ().height;
        System.out.println ("button: "+ d.toString());
        buttonpan.resize (d);
        invalidate ();
        validate ();
    }
    public boolean action (Event evt, Object what) 
    {
//        System.out.println ("evnt: " + evt.toString () + "act: " +
//                               what.toString ());
        if ((evt.target instanceof Button)) {
            try {            
                if (what.toString () == "Run") {
                    out.writeBytes ("~r\n");
                }
                if (what.toString () == "Interrupt") {
                    out.writeBytes ("~I\n");
                }
                if (what.toString () == "Kill") {
                    out.writeBytes ("~K\n");
                }
                if (what.toString () == "Calls") {
                    out.writeBytes ("bt\n");
                }
                } catch (IOException e) {
                    System.out.println ("Can't write text to debugger");
                }                
            
            return true;            
        }

        if ((evt.target instanceof TextField)) {
            try {
                String s;
                
                s = inbox.getText ();
                if (s.length () != 0)
                    lastline = s;
                outbox.appendText (lastline+"\n");                                
                out.writeBytes (lastline+"\n");
                inbox.setText ("");
            } catch (IOException e) {
                System.out.println ("Can't write text to debugger");
            }                
            return true;            
        }
        return false;
    }
    
}


// the stupid AWT doesn't have a way to limit the number of
// lines in a textArea so I have to implement it.

class TerminalArea extends TextArea 
{
    int maxlines;
    int curline;
    
    
    TerminalArea (int rows, int cols, int max) 
    {
        super (rows, cols);
        maxlines = max;
        curline = 0;
    }
    public void appendText (String s) 
    {
        String old = super.getText ();
        int i;
        // scan to see how many newlines the new text has.
        for (i = 0; i < s.length (); i++) {
            if (s.charAt (i) == '\n')
                curline++;
        }
        if (curline > maxlines) {
            int idx = 0;
            // need to chop off the delta amount
            for (i = 0; i < curline - maxlines; i++)
                idx = old.indexOf ('\n', idx) + 1;
            super.replaceText ("", 0, idx);
            curline = maxlines;
        }
        super.appendText (s);        
    }
    // catch setText's too to update curline
    public void setText (String s) 
    {
        int i;
        
        curline = 0;
        for (i = 0; i < s.length (); i++) {
            if (s.charAt (i) == '\n')
                curline++;
        }
        super.setText (s);
    }
    
}

        
class TerminalBox extends TerminalArea implements Runnable 
{
    Thread t;
    InputStream in;

    TerminalBox (InputStream i, int rows, int cols, int max) throws IOException
    {
        super (rows, cols, max);
        
        in = i;
        this.setEditable (false); // can't edit this
    }    
    
    public void start () 
    {
        t = new Thread (this);
        t.start ();
    }
    
    public void stop () 
    {
        t.stop ();
    }
    public void run () 
    {
        int len = 1;
        byte bf [] = new byte [512];
        while (len > 0) {
            try {
                len = in.read (bf);
            } catch (IOException e) {
                System.out.println ("Can't read from input.");
                break;
            }
            if (len > 0)
                this.appendText (new String (bf, 0, 0, len));

        }
    }
}
