/*
 *                 Copyright (c) Mar 28 16:26:19  MTCC
 *	Author: Michael Thomas
 *	Module: cgife.c
 *	Created: Fri Mar 28 16:26:19 1997
 *	Abstract:
 *	   front end for cgidbg and/or cgi programs for cgidbg
 */

/* Edit History: 
 */

#include <html.h>               /* must come first, sorts through most includes */
#include <sys/time.h>
#include <signal.h>


int iscgi = 0;
int tmo = 0;

void error (char * fmt, ...);

/* giveup after a certain amount of time on the accept calls */
void
giveup (int sigctx) 
{
    error ("giving up after %d seconds.\n", tmo);
    exit (1);
}

void usage () {
    error ("cgife: host port\n");
}



int main (int ac, char ** av) 
{
    fd_set fds, selmask;
    int fd, rv;
    char bf [1024];
    char * hname, * poname = 0;
    hrec * h;
    
    
    /* stdin is always set */
    FD_ZERO (&fds);

    gethostname (bf, 256);

    h = hrgetparams (0, ac, av);
    if (* (hname = hrget (h, "host"))) {
        poname = hrget (h, "port");
        preHTML ();
        iscgi = 1;
    } else if (ac < 3)
        usage ();
    else {
        hname = av [1];
        poname = av [2];
        FD_SET (0, &fds);        
    }
    
    signal (SIGALRM, giveup);
    alarm (tmo = 60);
    if ((fd = sockopen (hname, atol (poname))) < 0) {
        error ("cgife: connect\n");
        exit (0);
    }
    
    FD_SET (fd, &fds);
    alarm (tmo = 900);
    while (1) {
        selmask = fds;        
        rv = select (32, &selmask, 0, 0, 0);
        if (rv < 0) {
            if (errno == EINTR)
                continue;            
            error ("cgife: select error\n"); 
        }
        if (FD_ISSET (fd, &selmask)) {
            if ((rv = read (fd, bf, 1024)) <= 0) {
                exit (0);
            }
            write (1, bf, rv);
            alarm (tmo = 900);
        }
        if (FD_ISSET (0, &selmask)) {
            if (fgets (bf, 132, stdin) == NULL) {
                exit (0);
            }
            write (fd, bf, strlen (bf));
            alarm (tmo = 900);
        }
        
    }
    
}

            
int GETS (char * bf, int len)    
{
    int rv = 0;    
    /* this isn't kosher since a command could
       conceivably span a select() */
    len--;    
    while (len > 0) {
        char ch;
        if (read (0, &ch, 1) <= 0) {
            if (rv) {
                * bf++ = 0;
                return rv;
            }
            return EOF;
        }        
        if (ch == '\n') {
            * bf++ = 0;
            return rv;            
        }
        * bf++ = ch;
        rv++;
        len--;
        
    }
    * bf++ = 0;
    return rv;    
}




void 
error (char * fmt, ...) 
{
    va_list ap;
    char bf [512];

    VA_START (ap, fmt);
    vsprintf (bf, fmt, ap);
    va_end (ap);
    if (iscgi) {
        hterase ();
        preHTML ();
        startHTML ("cgife error", 0);
        par ();
        htprintf ("an error has occurred: %s\n", bf);
        endHTML ();
    } else
        fprintf (stderr, bf);    
    exit (0);
}
