/*
 *                 Copyright (c) May  3 11:19:08  MTCC
 *	Author: Michael Thomas
 *	Module: ckspam.c
 *	Created: Sat May  3 11:19:08 1997
 *	Abstract:
 *	   check the spam database for bozos
 */

/* Edit History: 
 */

#include <html.h>

/* check the standard input against the spam database,
   the message is emitted if OK, error otherwise
 */


int procmail = 0;
int debug = 0;
int dosend = 0;

FILE * posturl ();
char * gethdr ();
int rcvresp ();
char * webify ();


usage () 
{
    fprintf (stderr, "ckspam: [-pd] url\n");
    /* note: 0 is preferable to pass mail on booboo */
    exit (1);
}


main (int ac, char ** av) 
{
    char * hdr;
    int c;
    extern optind;
    FILE * fp;
    char * hdrs [5];
    
    while ((c = getopt (ac, av, "pds")) != -1) {
        switch (c) {
            case 'p':
                procmail = 1;
                break;
            case 'd':
                debug++;
                break;
            case 's':
                dosend = 1;
                break;
                
        }
    }
    if (optind >= ac)
        usage ();
    hdr = gethdr ();

    /* create the headers for the post */
    hdrs [0] = "cmd";
    hdrs [1] = "hdr";
    hdrs [2] = "hdr";
    hdrs [3] = webify (hdr);
    hdrs [4] = 0; 

    if ((fp = posturl (av [optind], hdrs)) == 0) {
        if (procmail == 0 && dosend)
            sendfile (hdr);
        exit (1);
    }
    if (rcvresp (fp) < 400) {
        if (procmail == 0 && dosend) {
            sendfile (hdr);
        }
        exit (1);
    }
    exit (0);
}


FILE * posturl (char * url, char ** hdr) 
{
    URL purl;
    int sock, i, len = 0;
    FILE * fp;
    char * p;
    int sts = 500;
    char bf [256];
    
    if (parseurl (url, &purl, 0) < 0)
        return 0;
    
    if ((sock = sockopen (purl.host, purl.port)) < 0)
        return 0;
    fp = fdopen (sock, "r+");
    /* kill name= urls */
    if (p = strchr (purl.file, '#'))
        * p = 0;
    sprintf (bf, "POST %s%s HTTP/1.0\r\n", purl.path, purl.file);
    write (sock, bf, strlen (bf));
    sprintf (bf, "Content-type: application/x-www-form-urlencoded\r\n");
    write (sock, bf, strlen (bf));
    for (i = 0; hdr [i]; i += 2) {
        len += strlen (hdr [i]);
        len += strlen (hdr [i+1])+1;
        if (hdr [i+2])
            len++;
    }
    len++;
    
    sprintf (bf, "Content-Length: %d\r\n\r\n", len);
    write (sock, bf, strlen (bf));
    /* dump the headers */
    for (i = 0; hdr [i]; i += 2) {
        write (sock, hdr [i], strlen (hdr [i]));
        write (sock, "=", 1);
        write (sock, hdr [i+1], strlen (hdr [i+1]));
        if (hdr [i+2])
            write (sock, "&", 1);
    }
    write (sock, "\r\n", 2);
    /* scan headers */
    if (fgets (bf, 256, fp) == NULL) 
        goto err;
    sscanf (bf, "%*s %d %*s\n", &sts);
    if (sts >= 300)
        goto err;    
    while (fgets (bf, 256, fp) != NULL) {
        if (! strcmp (bf, "\n") || ! strcmp (bf, "\r\n"))
            break;
        if ((p = strchr (bf, '\r')) || (p = strchr (bf, '\n')))
            * p = 0;
    }
    return fp;
err:
    fclose (fp); 
    return 0;
}


rcvresp (FILE * fp) 
{
    char bf [512];
    int rv = 0;

    bf [0] = 0;
    if (debug) {
        while (fgets (bf, 512, fp) != NULL) {
            if (sscanf (bf, "%d", &rv) == 0)
                rv = 0;
            fprintf (stderr, "response is: %s\n", bf);
        }
    } else {
        fgets (bf, 512, fp);
        if (sscanf (bf, "%d", &rv) == 0)
            rv = 0;
        if (procmail == 0)
            printf ("%s", bf);
    }    
    return rv;
}




sendfile (char * hdr) 
{
    int c;
    
    puts (hdr);
    while ((c = getc (stdin)) != EOF)
        putchar (c);
}


/* receive the headers of the mail message */

char *
gethdr () 
{
    char bf [4096];
    char * rv = 0;
    int cursz = 0, asize = 2048;
    
    rv = malloc (2048);
    while (fgets (bf, 4096, stdin) != NULL) {
        int lastsz = cursz;
        if (! strcmp (bf, "\n") || ! strcmp (bf, "\r\n"))
            break;
        cursz += strlen (bf);
        if (cursz >= asize) {
            asize = cursz + 1024;
            rv = realloc (rv, asize);
        }
        strcpy (rv + lastsz, bf);
    }
    return rv;
}

                  

        
        
