#include <sys/file.h>
#include <time.h>
#include <msql.h>
#include <html.h>


#define CONDBFIND  "/user/sfx/public_html/condbfind.html"
#define CONDBADMIN "/user/sfx/public_html/admin.html"

#define DBHOST "fasolt"
#define DBFILE "sfx"
#define ADMINFILE "/user/sfx/db/sfx.admin"
#define BASEURL "http://www.mtcc.com/~sfx/"
#define PASSSEED "sf"
#define ADMIN  "admin"

#define GENERIC "/user/sfx/public_html/generic.html"


int dbsock;

hrec * hrecs;
int nrecs;

char * nochoice = "No Choice/Other";

/*
 * Called con <db> <cmd>
 */

main (int ac, char ** av) 
{
    FILE * ap;
    hrec * in;
    char * cmd;

    preHTML ();   
    dbsock = msqlConnect (DBHOST);
    if (dbsock < 0)
        error ("can't open database");
    if (msqlSelectDB (dbsock, "sfx") < 0)
        error ("can't select database");
    if (hinitlogin ("fasolt", "condb", "sf", 60*60) < 0)
        error ("can't start up login database.");
    in = hrgetparams (0, ac, av);
    hputenv ("admin", "no");
#ifdef DEBUG
    hputenv ("debug", "yes");
#else
    hputenv ("debug", "no");
#endif
    if (* (cmd = hrget (in, "cmd")) == 0) {
        if (ac < 2) {
            if (htreadfile (CONDBADMIN) == 0)
                error ("can't read template.");
            htformnext ();
            htformnext ();
            htformnext ();
            
            htdumpfile ();
            exit (0);
        }            
        cmd = av [1];
    }    
    switch (* cmd) {
        case 'u':
            login (in);
            break;
        case 'f':
            find (in, 0);
            break;
        case 'l':              /* list */
            list (in);
            break;
        case 'a':              /* add */
            add (in);            
            break;
        case 'r':              /* remove */
            rem (in);
            break;
        default:
            error ("unknown command");
            break;
    }
    htdumpfile ();
    exit (0);
}


/* the def rec is more important than it seems. it contains all of
   the fields that we will fetch from the database as well as
   their default values */


hrec * getdefrec () 
{
    hrec * r = newhrec ();    

    hradd (r, "fullname", "");
    hradd (r, "pwd", "");
    hradd (r, "email", "");
    hradd (r, "phone", "");
    hradd (r, "snail", "");
    hradd (r, "credate", "");
    hradd (r, "number", "1");
    hradd (r, "web", "http://");
    hradd (r, "dates", "Aug 7-11");
    hradd (r, "scholarship", "$0");
    hradd (r, "thur", nochoice);
    hradd (r, "fri", nochoice);
    hradd (r, "satday", nochoice);
    hradd (r, "sateve", nochoice);
    hradd (r, "sunmorn", nochoice);
    hradd (r, "sunday", nochoice);
    hradd (r, "suneve", nochoice);
    hradd (r, "mon", nochoice);
    hradd (r, "lodging", nochoice);
    hradd (r, "muni", "no");
    hradd (r, "private", "no");
    hradd (r, "paid", "");
    return r;
    
}


login (hrec * in) 
{
    char epwd [50];
    char * u = hrget (in, "email");
    hrec * r, * login;
    hrec * found;
    
    /* either if login fails or we're not using the
       admin password and the usernames have changed,
       go through login again. */
    strlower (hrget (in, "email"));
    if ((login = hvrfysession (in, 0)) == 0 ||
         strcmp (hrget (login, "user"), hrget (in, "email"))) {
        char * pw1, * pw2;
        
        r = getdefrec ();
        /* it's not an error if the record isn't found. the ugly
           if below will figure that out later... */
        found = hmfind (dbsock, r, DBFILE, "email", hrget (in, "email"));
        strcpy (epwd, hrget (r, "pwd"));

        pw1 = hrget (in, "pwd");
        pw2 = hrget (in, "pwd2");

        if (* pw1 && * pw2) {
            if (found) {
                if (* epwd == 0)
                    login = hnewlogin (u, pw1, pw2, epwd);
                else
                    error ("can't change password.");
            } else            
                login = hnewlogin (u, pw1, pw2, epwd);
        } else
            login = hlogin (u, pw1, epwd);
        if (login == 0)  
            error ("Login failed.");
        hradd (in, "sessid", hrget (login, "sessid"));
    }
    if (strcmp (hrget (login, "user"), ADMIN))
        find (in, login);
    else {
        htelm * h;
        hputenv ("admin", "yes");
        h = htreadfile (CONDBADMIN);
        hloginbindall (in);
    }
}





find (hrec * in, hrec * login)
{
    hrec * r;
    htelm * h;
    char * pass;
    int isadmin;

    strlower (hrget (in, "email"));
    if (login == 0 && (login = hvrfysession (in, 0)) == 0)
        error ("invalid login information.");    

    isadmin = ! strcmp (hrget (login, "user"), ADMIN);    

    if (isadmin)
        hputenv ("admin", "yes");
    
    h = htreadfile (CONDBFIND);
    if (h == 0)
        error ("can't read template file");

    if (* hrget (in, "email") == 0)
        error ("You must supply an email address\n");
    
    r = getdefrec ();

    if (hmfind (dbsock, r, DBFILE, "email", hrget (in, "email")) == 0) 
        hradd (r, "email", hrget (in, "email"));
    hrmerge (r, in);
    htgotomark ("add");
    htformnext ();
    htbindform (r);
    htgotomark ("rem");
    htformnext ();
    htbindform (r);
}

add (hrec * in)
{
    long tm;
    char curtime [50];
    htelm * h;
    hrec * old, * login;
    int prv = 1;
    char * u;
    int isadmin;
        
    strlower (hrget (in, "email"));
    if (* (u = hrget (in, "email")) == 0)
        error ("You must supply an email address.");
    if ((login = hvrfysession (in, 0)) == 0)
        error ("login information invalid.");

    isadmin = ! strcmp (hrget (login, "user"), ADMIN);

    if (! strcmp (hrget (in, "button"), "Find")) {
        old = newhrec ();
        hradd (old, "email", hrget (in, "email"));
        find (old, login);
        return;
    }
    h = htreadfile (GENERIC);
    if (h == 0)
        error ("couldn't read template.");

    old = getdefrec ();
    if (isadmin == 0 && strcmp (hrget (login, "user"), u))
        error ("can't change the email address.");

    time (&tm);
    strcpy (curtime, ctime (&tm));
    chop (curtime);        
    if (hmfind (dbsock, old, DBFILE, "email", u) == 0) {
        /* use the incoming record as a base */
        old = in;
        hradd (old, "pwd", hrget (login, "pwd"));
        hradd (old, "credate", curtime);
    } else {
        /* merge everything into old */
        hrsetflg (old, "credate", HR_NOMERGE);
        hrsetflg (old, "pwd", HR_NOMERGE);
        hrsetflg (old, "pwd2", HR_NOMERGE);
        hrmerge (old, in);
    }
    /* if there wasn't a password, inherit the login password */
    if (* hrget (old, "pwd") == 0)
        hradd (old, "pwd", hrget (login, "pwd"));
    /* if they pressed the clear password button, clear it */
    if (! strcmp (hrget (in, "button"), "clear password")) {
        if (isadmin)
            hradd (old, "pwd", "");
        else
            error ("not logged in.");
    }    
    hrsetflg (old, "sessid", HR_HIDDEN);
    hrsetflg (old, "pwd2", HR_HIDDEN);
    hrsetflg (old, "button", HR_HIDDEN);

    nrecs++;
    hradd (old, "moddate", curtime);
    if (hmupdate (dbsock, old, DBFILE, "email", hrget (old, "email")) < 0) {
        error ("sql error: %s", msqlErrMsg);
    }
    htgotomark ("pageheader");
    if (isadmin)
        htprintf ("%s's record for con attendance has been updated.\n",
                  hrget (old, "email"));
    else {
        htprintf ("%s, your record for con attendance has been added.\n",
                  hrget (old, "fullname"));
        htgotomark ("pagebody");
        bq (2);
        htprintf ("Thanks for taking the time to fill it out<br>\n");
        htprintf ("If you need to change anything, just re-enter<br>\n");
        htprintf ("your email address and modify it to your heart's content.\n");
        bq (-2);
    }
}


rem (hrec * in) 
{
    hrec * old, * login;
    htelm * h = htreadfile (GENERIC);
    char * u;
    int isadmin;
    
    strlower (hrget (in, "email"));
    if (h == 0)
        error ("can't read template file.");    
    if (* (u = hrget (in, "email")) == 0)
        error ("You must supply an email address.");    
    if ((login = hvrfysession (in, 0)) == 0)
        error ("login information invalid.");
    isadmin = ! strcmp (hrget (login, "user"), ADMIN);
    
    if (isadmin == 0 && strcmp (hrget (login, "user"), u))
        error ("remove: can't change the email address.");
    
    old = getdefrec ();
    if (hmfind (dbsock, old, DBFILE, "email", u)) {
        if (hmdelete (dbsock, DBFILE, "email", hrget (in, "email")) < 0)
            error (msqlErrMsg);
        htgotomark ("pageheader");
        htprintf ("your record for con attendance has been deleted.\n");
        return;            
    }
    htgotomark ("pageheader");    
    htprintf ("your record was never added.\n");
}



int ucmp (const void * k1, const void * k2) 
{
    char * p1, * p2, * p;
    int rv;

    p1 = hrget (* (hrec **) k1, "fullname");    
    if (p = strrchr (p1, ' '))
        p1 = p+1;
    p2 = hrget (* (hrec **) k2, "fullname");    
    if (p = strrchr (p2, ' '))
        p2 = p+1;
    return strcasecmp (p1, p2);
}

int rcmp (const void * k1, const void * k2) 
{
    char * p1, * p2, * p;
    int rv;

    p1 = hrget (* (hrec **) k1, "sateve");    
    p2 = hrget (* (hrec **) k2, "sateve");    
    return strcasecmp (p1, p2);
}


static char * nbsp = "&nbsp;";


list (hrec * in) 
{
    hrec * p;
    int cnt = 0, acnt = 0, samt = 0, j;
    hrec ** vec, * login;
    int priv = 0, fmt;
    htelm * h = htreadfile (GENERIC);
    char * lastr = 0;
    
    struct lcmd {
        char * list;
        char * fmt;
        char * priv;
        char * targ;
    } * cmd;
    

    if (h == 0)
        error ("can't open template.");

    if (login = hvrfysession (in, 0))
        priv  = ! strcmp (hrget (login, "user"), ADMIN);

    if ((cmd = (struct lcmd *) split (hrget (in, "list"), ',')) == 0) 
        cmd = (struct lcmd *) split ("all,1,n,Attendees", ',');
    /* if not a privileged list, elevate their privilege */
    if (cmd->priv [0] == 'y' && ! priv)
        error ("admin password required.");
    fmt = atol (cmd->fmt);
    nrecs = readdb ();
    vec = alloca (nrecs * sizeof (vec));
    for (p = hrecs; p; p = p->flink) {
        if (! strcmp (hrget (p, "email"), "admin"))
            continue;        
        if (fmt > 0 || ! strcmp (hrget (p, cmd->list), cmd->targ)) {
            vec [cnt] = p;
            cnt++;
        }
    }    

    htgotomark ("pageheader");
    htprintf ("List of %s", cmd->targ);
    htgotomark ("pagebody");

    bq (2);    

    if (fmt == 5)
        qsort (vec, cnt, sizeof (vec), rcmp);
    else
        qsort (vec, cnt, sizeof (vec), ucmp);
    if (fmt == 4 || fmt == 3 || fmt == 6)
        dl (1);
    if (fmt == 5) {
        tableHTML (1, 1);
        th ("Party");
        th ("Restaurant");
        th ("# in party");
    }
    if (fmt == 6) {
        tableHTML (1, 1);
        th ("Name");
        th ("Party");
        th ("Saturday");
        th ("BBB");        
        th ("Muni");
        th ("Tee Shirt");
    }
            
    for (j = 0; j < cnt; j++) {
        int t;
        char url [512], * s;

        p = vec [j];
        /* construct a url if privileged. */
        if (priv) {
            strcpy (url, "http://");
            if (s = getenv ("SERVER_NAME")) 
                strcat (url, s);
            if (s = getenv ("SCRIPT_NAME"))
                strcat (url, s);
            strcat (url, "?cmd=find&email=");
            strcat (url, hrget (p, "email"));
            strcat (url, "&sessid=");
            strcat (url, hrget (login, "sessid"));
        } else
            url [0] = 0;        
        sscanf (hrget (p, "scholarship"), "$%d", &t);
        samt += t;
        
        /* don't bother with the admin record. */
        if (! strcmp (hrget (p, "private"), "yes") && ! priv)
            continue;
        
        switch (fmt) {
            case 1:
                if (priv)
                    aHTML (url, "");
                htprintf ("%s (%s, %s)\n", hrget (p, "fullname"),
                          hrget (p, "email"), hrget (p, "lodging"));
                if (priv)
                    endaHTML ();
                br (1);
                break;
            case 2:
                aHTML (url, "");
                htprintf ("%s (%s, %s)\n", hrget (p, "fullname"),
                          hrget (p, "email"), hrget (p, "scholarship"));
                endaHTML ();
                br (1);
                break;
            case 3:
                hl (4);
                dt ();
                aHTML (url, "");                
                htprintf ("%s (%s) has paid for:\n",
                          hrget (p, "fullname"), hrget (p, "email"));
                endaHTML ();
                hl (-4);
                dd ();
                pre (1);
                htprintf ("%s\n", hrget (p, "paid"));
                pre (0);
                break;
            case 4: 
            {

                
                hl (4);
                dt ();
                aHTML (url, "");                
                htprintf ("%s (%s)\n", hrget (p, "fullname"), hrget (p, "email"));
                endaHTML ();
                
                hl (-4);
                dd ();
                htprintf ("snail: %s<br>\n", hrget (p, "snail"));
                htprintf ("phone: %s<br>\n", hrget (p, "phone"));
                htprintf ("web: %s<br>\n", hrget (p, "web"));
                htprintf ("number in party: %s<br>\n", hrget (p, "number"));
                htprintf ("thurs: %s<br>\n", hrget (p, "thur"));
                htprintf ("fri: %s<br>\n", hrget (p, "fri"));
                htprintf ("satday: %s<br>\n", hrget (p, "satday"));
                htprintf ("sateve: %s<br>\n", hrget (p, "sateve"));
                htprintf ("sunmorn: %s<br>\n", hrget (p, "sunmorn"));
                htprintf ("suneve: %s<br>\n", hrget (p, "suneve"));
                htprintf ("mon: %s<br>\n", hrget (p, "mon"));
                htprintf ("lodging: %s<br>\n", hrget (p, "lodging"));
                htprintf ("muni: %s<br>\n", hrget (p, "muni"));
                htprintf ("scholarship: %s<br>\n", hrget (p, "scholarship"));
                htprintf ("private: %s<br>\n", hrget (p, "private"));
                htprintf ("paid:<br> <pre>%s</pre><br>\n", hrget (p, "paid"));
                htprintf ("credate: %s<br>\n", hrget (p, "credate"));
                htprintf ("moddate: %s<br>\n", hrget (p, "moddate"));
                break;
            }
            case 5:
                if (lastr && strcmp (lastr, hrget (p, "sateve"))) {
                    htprintf ("<tr><td valign=center colspan=2>");
                    td (0);
                    htprintf ("<td valign=center>%d", acnt);
                    td (0);
                    tr (0);
                    acnt = 0;
                }
                tr (1);
                td (1);
                if (priv)
                    aHTML (url, "");
                htprintf ("%s", hrget (p, "fullname"));
                if (priv)
                    endaHTML ();
                td (0);
                td (1);
                htprintf ("%s", lastr = hrget (p, "sateve"));
                td (0);
                td (1);
                htprintf ("%s", hrget (p, "number"));
                td (0);
                tr (0);
                break;
            case 6:             /* checkoff list */
                tr (1);
                td (1);
                htprintf ("%s<br>(%s)\n", hrget (p, "fullname"), hrget (p, "number"));
                td (0);
                td (1);
                if (! strncmp ("Reception", hrget (p, "fri"), 9))
                    htprintf ("yes\n");
                else
                    htprintf ("no\n");
                td (0);
                td (1);
                if (! strncmp ("Alcatraz", hrget (p, "satday"), 8) ||
                    ! strncmp ("Vertigo", hrget (p, "satday"), 7))
                    htprintf ("%s\n", hrget (p, "satday"));
                else
                    htprintf (nbsp);
                td (0);
                td (1);
                if (! strncmp ("Beach", hrget (p, "suneve"), 5))
                    htprintf ("yes\n");
                else
                    htprintf ("no\n");
                td (0);
                td (1);

                if (! strncmp ("yes", hrget (p, "muni"), 3))                
                    htprintf ("yes\n");
                else
                    htprintf ("no\n");
                td (0);
                td (1);                
                htprintf ("%s\n", nbsp);
                td (0);
                tr (0);
                break;
                
            default:
                if (priv)
                    aHTML (url, "");
                htprintf ("%s (%s)\n", hrget (p, "fullname"), hrget (p, "email"));
                if (priv)
                    endaHTML ();
                br (1);
                break;
        }
        acnt += hrgetint (p, "number");        
    }
    if (fmt == 4 || fmt == 3)
        dl (0);
    if (fmt == 5) {
        htprintf ("<tr><td valign=center colspan=2>");
        td (0);
        htprintf ("<td valign=center>%d", acnt);
        td (0);
        tr (0);
        acnt = 0;
        tableHTML (0, 0);
    }
    if (fmt == 6) {
        tableHTML (0, 0);
    }
    
    br (1);
    if (fmt == 2)
        htprintf ("%d total for $%d", acnt, samt);
    else if (fmt != 5)
        htprintf ("%d total. (note, this includes multi person parties and records marked private)", acnt);
    bq (-2);
}



readdb () 
{
    hrec * p;
    void * ctx = 0;
    int nrecs = 0;
    
    while (1) {
        p = getdefrec ();
        if (hmfetchrows (dbsock, p, DBFILE, &ctx) == 0)
            break;
        hrlink (&hrecs, p);
        nrecs++;
    }
    return nrecs;
}


error (char * str) 
{
    htelm * h;
    
    hterase ();
    preHTML ();
    if ((h = htreadfile (GENERIC)) == 0)
        startHTML ("condb error", BASEURL);
    else {
        htgotomark ("title");
        htprintf ("condb error");
    }
    htgotomark ("pageheader");
    par ();
    htprintf ("an error has occurred: %s\n", str);
    if (h == 0)
        endHTML ();
    else
        htdumpfile ();    
    exit (0);
}

