#include <sys/file.h>
#include <time.h>
#include <msql.h>
#include <html.h>

hrec * hrecs = 0;


#define DBFILE "dindin"
#define BASEURL "http://www.mtcc.com/~aric/"
#define DINDIN  "/user/aric/public_html/dindin.html"
#define DINLIST "/user/aric/public_html/dindinlist.html"
#define DINFIND "/user/aric/public_html/dindinfind.html"
#define GENERIC "/user/aric/public_html/generic.html"

int dbsock;


/*
 * Called todo <db> <cmd>
 */

main (int ac, char ** av) 
{
    FILE * ap;
    hrec * in;
    char * cmd;

    preHTML ();   
    dbsock = msqlConnect ("fasolt");
    if (dbsock < 0)
        error ("can't open database");
    if (msqlSelectDB (dbsock, "bugbase") < 0)
        error ("can't select database");
    in = hrgetparams (0, ac, av);

    if (hinitlogin ("fasolt", "dindin", "zz", 60*60) < 0)
        error ("can't start up login database.");

    if (* (cmd = hrget (in, "cmd")) == 0) {
        if (ac < 2)
            error ("not enough arguments");
        cmd = av [1];
    }
    switch (* cmd) {
        case 'u':
            login (in);
            break;
        case 'f':              /* find */
            find (in);
            break;
        case 'l':              /* list */
            list (in);
            break;
        case 'a':              /* add */
            add (in);            
            break;
        case 'r':              /* remove */
            rem (in);
            break;
            
        default:
            error ("unknown command");
            break;
    }
    htdumpfile ();
    exit (0);
}


          
/* the def rec is more important than it seems. it contains all of
   the fields that we will fetch from the database as well as
   their default values */

hrec *
getdefrec () 
{
    long tm;
    hrec * r;
    char bf [256];
    struct tm * tmp;
    
    r = newhrec ();
    time (&tm);
    tmp = localtime (&tm);
    /* swine! this close to the millenium and still using a
       fucked up date format!
     */
    strftime (bf, 256, "%y%m%d", tmp);    
    
    hradd (r, "cdate", bf);
    hradd (r, "ddate", bf);
    hradd (r, "updater", "Aric");
    hradd (r, "attendee", "Mike,Aric");
    hradd (r, "occassion", "");
    hradd (r, "c1", "");
    hradd (r, "c2", "");
    hradd (r, "c3", "");
    hradd (r, "wine", "");
    hradd (r, "notes", "");
    hradd (r, "chef", "Mike");
    return r;
}


login (hrec * in) 
{
    char pwd [50];
    char * u = hrget (in, "updater");
    hrec * login;
    if (hpwdfile ("/etc/passwd", u, pwd) < 0)
        error ("no such user %s", u);
    if ((login = hlogin (u, hrget (in, "pwd"), pwd)) == 0)
        error ("login failed.");
    hradd (in, "sessid", hrget (login, "sessid"));
    hloginbindall (in);
    /* go directly to find */
    find (in);    
}



find (hrec * in)
{
    hrec * r = 0;
    htelm * h = htreadfile (DINFIND);
    char bf [256], * p;

   
    r = getdefrec ();
    if (hmfind (dbsock, r, DBFILE, "ddate", hrget (in, "ddate")) == 0) {
        if (* hrget (in, "updater") == 0)
            error ("You must supply your name.");
        if (* hrget (in, "ddate"))
            hradd (r, "ddate", hrget (in, "ddate"));
    }
    /* propogate the session id along the way */
    hradd (r, "sessid", hrget (in, "sessid"));
    htgotomark ("pagehead");
    htgotomark ("add");
    htformnext ();
    htbindform (r);
    htgotomark ("rem");
    htformnext ();
    htbindform (r);
}

int ucmp (const void * p1, const void * p2) 
{
    int a, b;
    
    a = atol (hrget (* (hrec **) p1, "ddate"));
    b = atol (hrget (* (hrec **) p2, "ddate"));
    return a - b;
}

listcell (char * var, char * val, hrec * r) 
{    
    char url [256], * s;
    int t;

    if (! strcmp (var, "ddate")) {
        strcpy (url, "http://");
        if (s = getenv ("SERVER_NAME")) 
            strcat (url, s);
        if (s = getenv ("SCRIPT_NAME"))
            strcat (url, s);
        sprintf (url+strlen (url), "?cmd=find&ddate=%s", val);
        aHTML (url, val);
    } else
        htprintf ("%s", val);
    return 1;
}


list (hrec * in) 
{
    hrec * p;
    int i = -1, j;
    int cnt = 0, samt = 0;
    hrec ** vec;
    htelm * ht = htreadfile (DINLIST), * tbl;
    int nrecs;    

    if (ht == 0) {
        error ("can't open template.");
    }    
    nrecs = readdb ();
    vec = alloca (nrecs * sizeof (vec));
    for (p = hrecs; p; p = p->flink) {
        vec [cnt] = p;
        cnt++;
    }
    qsort (vec, cnt, sizeof (vec), ucmp);
    tbl = htgettabledef (hrget (in, "type"));
    htgotomark ("pagebody");
    httablestart (tbl);
    for (j = 0; j < cnt; j++) {
        p = vec [j];
        htbindtable (tbl, p, listcell);
    }
    httableend ();
}



add (hrec * in)
{
    long tm;                
    hrec * old = 0;
    char url [256], curtime [100];
    htelm * ht = htreadfile (GENERIC);
    hrec * login;
   
    if (ht == 0)
        error ("can't open template file.");

    if (hvrfysession (in, 0) == 0)
        error ("login error -- try logging in again.");
   
    time (&tm);
    strcpy (curtime, ctime (&tm));
    chop (curtime);
    old = getdefrec ();

    if (hmfind (dbsock, old, DBFILE, "ddate", hrget (in, "ddate")) == 0) {
        /* these could conceivably be taken from the
           the original form, but they may be out of
           date. be cautious */
        old = in;
        hradd (old, "cdate", curtime);
    } else {
        /* don't touch the cdate */
        hrsetflg (old, "cdate", HR_NOMERGE);
        hrmerge (old, in);
    }
    hrsetflg (old, "sessid", HR_HIDDEN);    
    if (hmupdate (dbsock, old, DBFILE, "ddate", hrget (old, "ddate")) < 0) {
        error (msqlErrMsg);
    }
    htgotomark ("pageheader");
    htprintf ("%s's dinner has been updated.\n",  hrget (old, "ddate"));
    htgotomark ("pagebody");
    br (1);
}




rem (hrec * in)
{
    hrec * r;
    htelm * ht = htreadfile (GENERIC);    

    if (ht == 0)
        error ("can't open template file.");

    if (hvrfysession (in, 0) == 0)
        error ("login error -- try logging in again.");
    
    if (* hrget (in, "ddate") == 0)
        error ("You must supply a date.");
    if (hmdelete (dbsock, DBFILE, "ddate", hrget (in, "ddate")) > 0) {
        htgotomark ("pageheader");
        htprintf ("%s's dinner has been deleted.\n", hrget (in, "ddate"));
        htgotomark ("pagebody");
        par ();
        return;            
    }
    htgotomark ("pageheader");
    htprintf ("couldn't delete record.\n");
    htgotomark ("pagebody");
    par ();
    br (1);
}



readdb () 
{
    hrec * p;
    void * ctx = 0;
    int nrecs = 0;
    
    while (1) {
        p = getdefrec ();
        if (hmfetchrows (dbsock, p, DBFILE, &ctx) == 0)
            break;
        hrlink (&hrecs, p);
        nrecs++;
    }
    return nrecs;
}

readdbq (char * fmt, char * a1, char * a2) 
{
    hrec * p;
    void * ctx = 0;
    int nrecs = 0;
    
    while (1) {
        p = getdefrec ();
        if (hmfetchrowsf (dbsock, p, DBFILE, &ctx, fmt, a1, a2) == 0)
            break;
        hrlink (&hrecs, p);
        nrecs++;
    }
    return nrecs;
}


error (char * str) 
{
    htelm * h;
    
    hterase ();
    preHTML ();
    if ((h = htreadfile (GENERIC)) == 0)
        startHTML ("dindin error", BASEURL);
    else {
        htgotomark ("title");
        htprintf ("dindin error");
    }
    htgotomark ("pageheader");
    par ();
    htprintf ("an error has occurred: %s\n", str);
    if (h == 0)
        endHTML ();
    else
        htdumpfile ();    
    exit (0);
}


