/*
 *                 Copyright (c) Jul  8 11:47:32  MTCC
 *	Author: Michael Thomas
 *	Module: htbl.c
 *	Created: Tue Jul  8 11:47:32 1997
 *	Abstract:
 *	   create a file from a template and a set of files
 *         which contain tab separated fields to produce an
 *         html table.
 */

/* Edit History: 
 */

#include <html.h>

int border = 1;

main (int ac, char ** av) 
{
    FILE * in;
    int cmd;
    extern char * optarg;
    extern int optind;
    
    
    if (ac < 2)
        usage ();
    while ((cmd = getopt (ac, av, "t:b:")) != -1) {
        switch (cmd) {
            case 't':
                htreadfile (optarg);
                break;
            case 'b':
                border = atol (optarg);
                break;
            default:
                usage ();
        }
    }
    /* the rest are files to be emitted */
    tableHTML (1, border);
    for (; optind < ac; optind++) 
        dumptb (av [optind]);
    tableHTML (0, 0);
    htdumpfile ();
}

    
        
dumptb (char * fn) 
{
    FILE * fp = fopen (fn, "r");
    char bf [512];

    if (fp == NULL) {
        fprintf (stderr, "can't open %s\n", fn);
        return;
    }
    while (fgets (bf, 512, fp) != NULL) {
        char * p, * p2 = bf;
        char tmp [512];
        tr (1);        
        for (p = bf; * p; p++) {
            if (* p == '\t') {
                /* don't emit one on \t\t */
                if (p > p2) {
                    td (1);
                    strncpy (tmp, p2, p-p2);
                    tmp [p-p2] = 0;
                    htprintf ("%s", tmp);
                    td (0);
                }
                p2 = p+1;
            } else if (*p == '\f') {
                tr (0);
                tableHTML (0, 0);
                tableHTML (1, border);
                tr (1);
                p2 = p + 1;
            }
            
        }
        if (p > p2) {
            td (1);
            strncpy (tmp, p2, p-p2);
            tmp [p-p2] = 0;
            htprintf ("%s", tmp);
            td (0);
        }
                
        tr (0);
        htprintf ("\n");
    }
            
}
        

usage () 
{
    fprintf (stderr, "htbl: [-t template] [files]\n");
    exit (1);
}



tr (on) 
{
    htprintf ("<%str>", on ? "" : "/");
}
td (on) 
{
    htprintf ("<%std>", on ? "" : "/");
}

tableHTML (int on, int border) 
{
    if (on) 
        htprintf ("<table border=%d>", border);
    else
        htprintf ("</table>");
}


