/*
 *                 Copyright (c) May  8 16:30:08  MTCC
 *	Author: Michael Thomas
 *	Module: spamctl.c
 *	Created: Thu May  8 16:30:08 1997
 *	Abstract:
 *	   spam control: things that you normally put in a cron job.
 */

/* Edit History: 
 */

#include <html.h>

#include "spam.h"

#define DBHOST "fasolt"

main (int ac, char ** av) 
{
    extern char * optarg;
    int c;
    hrec * p;
    
    in = newhrec ();
    sock = hminit (DBHOST, SPAMDB);
    readpeers ();
    hradd (in, "text", "");
    while ((c = getopt (ac, av, "up:")) != -1) {
        switch (c) {
            case 'p':
                hradd (in, "since", optarg);
                purgelog (in);                
                break;
            case 'u':
                for (p = peers; p; p = p->flink) {
                    if (! strcmp (hrget (p, "name"), "local") ||
                        (hrgetint (p, "flags") & PEER_SHADOW))
                        continue;
                    hradd (in, "name", hrget (p, "name"));
                    updpeer (in);
                }
                break;
            case '?':
                fprintf (stderr, "spamctl: [-pu]\n");
                break;
        }
        
    }
    exit (0);
}





