/*
 *		    Copyright (c) 1986 Gordian Inc.
 *	 Created Wed Sep 24 13:31:57 1986 By Michael A Thomas
 */

#ifndef h_hash
#define h_hash

/* a hash table is a set of pointers to some sort of structure which
   has as its first element an flink, and as its second element the nodes
   real name.
 */

struct h_table {
    struct h_node ** h_tab;
    long h_size;
    int hits;                   /* number of access */
    int depth;                  /* all comparisons considered */
    struct h_node * seanode;
    int seaidx;
};

struct h_node {
    struct h_node * flink;		/* the forward bucket link */
    void * h_name;
    void * h_obj;
};

/* Function prototypes */

struct h_table *h_init(int size);
void h_destroy (struct h_table *h);
void * h_get (struct h_table *tb, const char *s);
struct h_node *  h_put (struct h_table *tb, const char *s, void * o);
int h_del (struct h_table *tb, const char *s);
void h_analyse (struct h_table * tb, int * sz, int * ptot, int * min, int * max, double * avg, int * nempty);
void h_printstats (const char * name, struct h_table * tb, int first) ;
void * h_first (struct h_table * tbl);
void * h_next (struct h_table * tbl);


#endif
