/*
 *                 Copyright (c) Apr 11 08:08:34  MTCC
 *	Author: Michael Thomas
 *	Module: hcond.c
 *	Created: Fri Apr 11 08:08:34 1997
 *	Abstract:
 *	   Environment variables
 */

/* Edit History: 
 */

#include "html.h"

static hrec * global = 0;


void hputenv (const char * var, const char * val) 
{
    hrec * h;
    
    /* self initialize. */
    if (global == 0)
        global = newhrec ();
    /* use h so we can deal with lexical scoping later. */
    h = global;
    hradd (h, var, val);
}

/* unlike its cousin hrget, this returns 0 if not
 * there, and the string if available.
 */

char * hgetenv (const char * var)
{
    hrec * h = global;
    hrecelm * he;
    
    
    if (h == 0)
        return 0;
    he = h_get (h->htbl, var);
    if (he)
        return he->val;
    return 0;
}

            

/* test the expansion of the condtional at element h */

int hcond (htelm * h) 
{
    struct token * p = htkgetword (h->tk, 1);
    char * gval;
    
    if (p == 0)
        return 0;
    /* if not even part of the environment, bzzt. */
    if ((gval = hgetenv (p->name)) == 0)
        return 0;

    /* eval if there a val (ie <$if foo=bar>) */
    if (p->flink && (p->flink->flags & TK_VAL)) {
        if (! strcmp (gval, p->flink->name))
            return 1;
        else
            return 0;
    } else
        return 1;
}


    


