/*
 *                 Copyright (c) Apr 12 19:10:07  MTCC
 *	Author: Michael Thomas
 *	Module: hdbm.c
 *	Created: Sat Apr 12 19:10:07 1997
 *	Abstract:
 *	   DBM interface to hrecs 
 */

/* Edit History: 
 */

#include "html.h"

#ifdef WANTDBM


int hdbminit (char * base) 
{
    return dbminit (base);
}


hrec * hdbmfind (char * key, hrec * hr)
{
    datum k, rv;
    k.dptr = key;
    k.dsize = strlen (key);
    rv = fetch (k);
    if (rv.dptr == NULL)
        return 0;
    rv.dptr [rv.dsize] = 0;
    hr = hrreadstrrec (hr, rv.dptr);
    return hr;    
}


hrec * hdbmfetchrows (hrec * hr, void ** ctx, char * var, char * val) 
{
    datum rv, d, * p;

    if (* ctx == 0) {
        p = malloc (sizeof (datum));
        d = firstkey ();
        * ctx = p;
    } else {
        p = * ctx;
        d = * p;
        d = nextkey (d);
    }    
    while (d.dptr != NULL) {
        rv = fetch (d);
        rv.dptr [rv.dsize] = 0;
        hrreadstrrec (hr, rv.dptr);        
        if (var == 0 || ! strcmp (hrget (hr, var), val)) {
            * p = d;
            return hr;
        }
        d = nextkey (d);
    }
    return 0;            
}


int hdbmupdate (char * key, hrec * hr) 
{
    datum k, v;
    char bf [2048];
    
    k.dptr = key;
    k.dsize = strlen (key);
    if (hrdumpstrrec (hr, bf, 2048) < 0)
        return 0;
    v.dptr = bf;
    v.dsize = strlen (bf);
    if (store (k, v) < 0)
        return -1;
    return 1;
}

int hdbinsert (char * key, hrec * hr) 
{
    return hdbmupdate (key, hr);
}

int hdbmmax (char * field) 
{
    void * ctx = 0;
    hrec * hr = newhrec ();
    int rv = 0;

    hraddint (hr, field, 0);
    while (hdbmfetchrows (hr, &ctx, 0, 0))
        if (hrgetint (hr, field) > rv)
            rv = hrgetint (hr, field);
    hrfree (hr);
    return rv;
}




int hdbmdelete (char * key) 
{
    datum k;
    k.dptr = key;
    k.dsize = strlen (key);
    if (delete (k) < 0)
        return -1;
    return 1;
}


#endif
