package mtcc.libht;

import mtcc.libht.*;
import java.net.*;


class hURL 
{
  
    String proto;
    String host;
    int port;
    String path;
    String file;
    String parameters;

/*
 * parse a URL into its components. I really should write
 * a regular expression parser for this.
 */

    
public 
    hURL (String url, hURL base) 
    {
    
        String nurl;
        int i, urlp;
        
        if (url == null || url.length () == 0)
            url = "/";
        port = 80;

        // first of all, split off any parameters from the url.
        // paramaters can be null.
        if ((i = url.indexOf ('?')) >= 0) {
            parameters = url.substring (i, url.length ());
            url = url.substring (0, i);
        }
        
        
        /* special case of relative path name: use base url */    
        if (url.indexOf (':') < 0 && base != null) {
            String postr = base.port == 80  ? "" : ":"+base.port;
            
            if (url.charAt (0) == '/')
                nurl = base.proto + "://" + base.host + postr + url;
            else {
                if (url.length () == 0 || url.charAt (0) == '#')
                    nurl = base.proto + "://" + base.host + postr + base.path+base.file+url;
                
                else
                    nurl = base.proto + "://" + base.host + postr + base.path+url;
            }
            url = nurl;            
        } else if (url.length () == 0)
            url = "/";


        if ((urlp = url.indexOf (':')) >= 0) {
            proto = url.substring (0, urlp);
            urlp++;
        } else {
            proto = "http";
            urlp = 0;
        }
        host = "";
        if (url.startsWith ("//", urlp)) {
            urlp += 2;            
            /* optional port number? */
            if ((i = url.indexOf (':', urlp)) >= 0) {
                host = url.substring (urlp, i);
                urlp = i+1;                
                if ((i = url.indexOf ('/', urlp)) < 0)
                    i = url.length ();
                
                port = Integer.parseInt (
                    url.substring (urlp, i));
                urlp = i;
            } else if ((i = url.indexOf ('/', urlp)) >= 0) {                
                host = url.substring (urlp, i);
                urlp = i;
            } else {
                host = url;
                url = "/";
                urlp = 0;
            }        
        } else {
            try {
                host = InetAddress.getLocalHost ().getHostName ();
            } catch (UnknownHostException e) {
                // ignore this.                
                System.out.println (e.toString());
            }            
        }
        /* strip any ./ and ../ in the path now */
        path  = stripdotdot (url.substring (urlp, url.length ()));

        // append a leading slash if necessary 
        if (path.charAt (0) != '/')
            path = "/" + path;

    
        /* sort of a strrchr to find the last '/' in the real path*/
        /* note that the rigamaroll here with 1 is because paths
           all start with an initial / which is the separator
           between the host and the path */        
        for (i = path.length () -1; i >= 1; i--)
            if (path.charAt (i) == '/') 
                break;

        if (path.charAt (i) != '/' || i == 0)
            i = -1;
    
        /* /path/... or /path */            
        if (i >= 0) {
            file = path.substring (i+1, path.length ());
            path = path.substring (0, i+1);
        } else {
            /* if /~mike or /file.html */
            if (path.length () > 1 && path.charAt (1) != '~') {
                file = path.substring (1, path.length ());
                path = "/";
            } else {
                path += "/";
                file = "";
            }        
        }
        /* this is extremely sketchy. it should be something, but
           that something is a function of the HTTPD, not us. Punt
           for now; it means we won't always distinguish
           /foo/bar/ from /foo/bar/index.htm or somesuch. oh well.
           */
        if (file.length () == 0)
            file = "index.html";
    }

// public 
//       hURL (String url) 
//       {
//           hURL (url, (hURL) null);
//       }
    
private String
    stripdotdot (String path) 
    {
        int i, j, len = path.length ();
        StringBuffer p = new StringBuffer ();
        
        for (i = 0; i < len;) {
            if (path.startsWith ("../", i)) {
                for (j = p.length ()-2; j >= 0; j--)
                    if (p.charAt (j) == '/') {
                        p.setLength (j+1);
                        break;
                    }                
                i += 3;                
            } else if (path.startsWith ("//", i)) {
                i++;
            } else
                p.append (path.charAt (i++));
            
        }
        return p.toString ();
    }

    
public       
    String toString () 
    {
        String rv;

        if (proto.equals ("http") || proto.equals ("ftp")) {
            if (port == 80)
                rv = proto + "://" + host+path+file;
            else
                rv = proto + "://" + host+":"+port+path+file;
        } else {
            rv = proto + ":" + path;
        }
        return rv;
    }


}
