/*
 * Common Web interface routines for cgi stuff.
 * 970208/mat
 */

package mtcc.libht;

import java.lang.*;
import mtcc.libht.*;



public class html  extends hform
{
    
public 
void preHTML ()
    {
        printf ("Content-type: text/html\n<$mark mime-headers>\n");
    }

public 
    void preTEXT ()
    {
        printf ("Content-type: text/plain\n<$mark mime-headers>\n");
    }


public 
    void startHTML (String title, String base)
    {
        printf ("<html><head><base href="+ (base != null ? base : "/") + ">");    
        printf ("<title>" + title + "</title></head>\n");
    
        printf ("<BODY>\n");    
        printf ("<center><h1>" + title + "</h1></center>");
    }

public     
    void endHTML ()
    {
        printf ("<p></body></html>\n");
        dumpfile ();
    
    }

public 
    void form (String method, String action, String parm) 
    {
        if (parm != null)
            printf ("<form method="+ method +
                      " action=" + action +
                      "?" + parm + ">\n");        
        else
            printf ("<form method="+ method +
                      " action=" + action + ">\n");
    }

public 
    void endform ()
    {
        printf ("</form>");
    }

public 
    void select (String label, String name, String vec [], String selected) 
    {
        int i;
        printf (label+ "<select name=\"" + name + "\">\n");
        for (i = 0; i < vec.length; i++) {
            if (selected.equals (vec [i]))
                printf ("<option selected>" + vec [i] +"\n");
            else
                printf ("<option>" + vec [i] + "\n");
        }
        printf ("</select>\n");
    }

public 
    void option (String val, String txt, int selected)
    {

        if (val != null) 
            printf ("<option value=\""+ webquote (val) +
                      "\"" + (selected != 0 ? " selected" : "") +
                      ">" + txt + "\n");
        else
            printf ("<option " + (selected != 0 ? " selected" : "") +
                      ">" + txt + "\n");        
    }


public 
    void radio (String label, String name, String vec [], String selected)
    {
        int i;
        
        printf (label);
        for (i = 0; i < vec.length; i++)
            if (selected.equals (vec [i]))
                printf ("<input type=radio name=\""+ name +
                          "\" value=\""+ webquote (vec [i]) +
                          "\" checked>"+ vec [i] +
                          "\n");
            else
                printf ("<input type=radio name=\""+ name +
                          "\" value=\""+ webquote (vec [i]) +
                          "\">"+ vec [i] +
                          "\n");
    }

public 
    void check (String label, String name, String valtag, String val) 
    {

        printf (label);
        
        printf ("<input type=checkbox name=\"" + name +
                  "\" value=\"" + webquote (valtag) +
                  "\"" + (val.equals (valtag) ? " checked>" : ">"));
        
    }

public static final int reset = 0;
public static final int submit = 1;
public static final int hidden = 2;
public static final int checkbox = 3;
public static final int input = 4;
public static final int image = 5;
public static final int password = 6;

public 
    void input (String label, String name, String value,
                    int type, int size, int maxsize) 
    {
        String t = ">\n";
        
        printf (label);
        
        switch (type) {
            case reset:
                t = "type=reset>\n";
                break;
            case submit:
                t = "type=submit>\n";
                break;
            case hidden:
                t = "type=hidden>\n";
                break;
            case checkbox:
                t = "type=check>\n";
                break;
            case password:
                t = "type=password size="+size+ " maxsize="+maxsize+">\n";
                break;
            case input:
                t = "size="+size+ " maxsize="+maxsize+">\n" ;
                break;
        }
        printf ("<input name=\""+ name +
                   "\" value=\""+ webquote (value) +
                   "\" " + t);
    }

public 
    void textHTML (String label, String name, String val, int cols, int rows) 
    {
        
        printf (label + "<textarea name=\""+ name +
                  "\" cols="+ cols +
                  "rows=" + rows +
                  ">" + webquote (val) +
                  "</textarea>\n");
    }

public     
    void anchor (String url, String txt) 
    {
        printf ("<a href=\""+ url + "\">");
        if (txt != null)
            printf (txt + "</a>");
    }

public 
    void endanchor ()
    {
        printf ("</a>");
    }

public 
    void dl (int on)
    {
        if (on != 0)
            printf ("<dl>");
        else
            printf ("</dl>");
    }

public     
    void dt ()
    {
        printf ("<dt>");
    }

public     
    void dd ()
    {
        printf ("<dd>");
    }

public 
    void pre (int on)
    {
        if (on != 0)
            printf ("<pre>");
        else
            printf ("</pre>");
    }


public 
    void center (int on) 
    {
        if (on != 0)
            printf ("<center>");
        else
            printf ("</center>");
    }

public 
    void br (int n) 
    {
        while (n-- > 0)
            printf ("<br>");
    }
public 
    void par ()
    {
        printf ("<p>\n");
    }

public 
    void bq (int n) 
    {
        if (n > 0)
            while (n-- > 0)
                printf ("<blockquote>");
        else
            while (n++ < 0)
                printf ("</blockquote>");
    }
public 
    void hr ()
    {
        printf ("<hr>");
    }

public 
    void hl (int n) 
    {
        if (n > 0)
            printf ("<h"+n+">");
        else
            printf ("</h" + (-n) + ">");
    }



}
