/*
 *                 Copyright (c) May 23 11:49:34  MTCC
 *	Author: Michael Thomas
 *	Module: token.java
 *	Created: Fri May 23 11:49:34 1997
 *	Abstract:
 *	   parse the contents of html markup tags
 */

/* Edit History: 
 */


package mtcc.libht;

import mtcc.libht.*;
import java.lang.*;
import java.io.*;

class varval 
{
    public String name;
    public int val;

public
    varval (String s, int v) 
    {
        name = s;
        val = v;
    }   
}


public class token
{
    String name;
    int flags;
    token flink;
    public static final int TK_TAG = 1;    
    public static final int TK_ISEND = 2;    
    public static final int TK_VAR = 4;
    public static final int TK_VAL = 8;
    public static final int TK_HASQ = 0x10;
    static varval tags [], intype [];
    

        
    static 
    {
        tags = new varval [17];
        int i = 0;
        
        
        tags [i++] = new varval ("form", htelm.H_FORM);
        tags [i++] = new varval ( "input", htelm.H_INPUT);
        tags [i++] = new varval ( "option", htelm.H_OPTION);
        tags [i++] = new varval ( "select", htelm.H_SELECT);
        tags [i++] = new varval ( "textarea", htelm.H_TXTAREA);
        tags [i++] = new varval ( "a", htelm.H_ANCHOR );
        tags [i++] = new varval ( "$table", htelm.H_TABLEDEF);
        tags [i++] = new varval ( "table", htelm.H_TABLE);
        tags [i++] = new varval ( "th",   htelm.H_TBHDR);
        tags [i++] = new varval ( "tr",   htelm.H_TBROW);
        tags [i++] = new varval ( "td",   htelm.H_TBCELL);
        tags [i++] = new varval ( "$mark", htelm.H_MARKER);
        tags [i++] = new varval ( "$date", htelm.H_DATE);
        tags [i++] = new varval ( "$include", htelm.H_INC);
        tags [i++] = new varval ( "$if", htelm.H_IF);
        tags [i++] = new varval ( "$set", htelm.H_SET);
        tags [i++] = new varval ( "$else", htelm.H_ELSE);

        i = 0;
        intype = new varval [6];        
        intype [i++] = new varval ("radio", htelm.H_RADIO);
        intype [i++] = new varval ("checkbox", htelm.H_CHECK );
        intype [i++] = new varval ( "submit", htelm.H_SUBMIT);
        intype [i++] = new varval ("reset", htelm.H_RESET );
        intype [i++] = new varval ("text", htelm.H_INPUT );
        intype [i++] = new varval ("password", htelm.H_PASSWORD );

    }
    
    // empty constructor 
    token () 
    {}

/*
 * tokenize a string following 
 */

    static token
    tokenize (StringBuffer txt, hparse cur) throws hparseException
    {
        token head, t, prev = null;
        StringBuffer word = new StringBuffer ();
        int goteq = 0;
        int i = 0, len = txt.length ();
        char ch;
        
        if (len < 3)
            return null;
        
        if (txt.charAt (i++) != '<' || txt.charAt (i) == '!')
            return null;
        head = t = new token ();
        t.flags = TK_TAG;
        for (; i < len; i++) {
            ch = txt.charAt (i);
            if (ch == '/' && (t.flags & TK_TAG) != 0) {
                t.flags |= TK_ISEND;
                continue;
            }
            switch (ch) {
                case '\"':
                    i++;
                    /* behave like normal, but strip the quotes */
                    while (i < len && txt.charAt (i) != '\"') 
                        word.append (txt.charAt (i++));
                    t.flags |= TK_HASQ;
                    if (i == len)
                        throw new
                            hparseException ("unclosed quote in text '"
                                 + word.toString()+"'", cur);
                    break;
                case '=':
                    if (word.length () == 0)
                        goteq = 1;
                    else
                        goteq = 2;                
                default:
                    if ((Character.isSpace (ch) || ch == '=' || ch == '>')) {
                        if (word.length () == 0 && (t.flags & TK_HASQ) == 0)
                            break;
                        /* seal off this tag */
                        if (prev != null)
                            prev.flink = t;
                        t.name = word.toString ();
                        if (goteq == 1){
                            t.flags |= TK_VAL;
                            t.flags &= ~ TK_VAR;
                        }
                        // strlower everthing but vals. */
                        if ((t.flags & TK_VAL) == 0)
                            t.name= t.name.toLowerCase ();
                        prev = t;
                        t = new token ();
                        t.flags = goteq == 2 ? TK_VAL : TK_VAR;
                        word.setLength (0);
                        goteq = 0;                    
                    } else
                        word.append (ch);
                    break;
            }
        }
        if (head.name == null) 
            return null;
        return head;
    }


/*
 * get the n'th word in the token list
 * observed.
 */

public token 
    getword (int n) 
    {
        token tk = this;
        while (n-- > 0) {
            if (tk.flink == null)
                return null;
            tk = tk.flink;
        }
        return tk;
    }

/*
 * get the value of var in the given token list
 */

public String
    getval (String var) 
    {
        token tk = this;
        for (; tk != null; tk = tk.flink) {
            if ((tk.flags & TK_VAR) != 0 && tk.name.equalsIgnoreCase (var))
                if (tk.flink != null) {

                    tk = tk.flink;
                    if ((tk.flags & TK_VAL) != 0)
                        return tk.name;
                } else
                    return "";      /* debatable: found the var, but no val */
        }
        /* this is clearly an error. */
        return null;
}

public token  
    ckvar (String var) 
    {
        token tk = this;
        for (; tk != null; tk = tk.flink) {
            if ((tk.flags & TK_VAR) != 0 && tk.name.equalsIgnoreCase (var))
                return tk;
        }
        /* this is clearly an error. */
        return null;
    } 

/*
 * decompose a tag. The return value is -1..1 which
 * means pop, donothing, push respectively.
 */
public static int 
    parsetag (htelm h, hparse cur)
    throws hparseException, FileNotFoundException, IOException
    {
        int i;
        int rv;

        if ((h.tk = tokenize (h.body, cur)) == null) {
            /* boring for some reason, bail now */
            return 0;
        }
    
        /* should bsearch the array, but linear is ok if it's
           small */

        
        for (i = 0; i < tags.length; i++) {
            // was strncmp, not sure why..
            if (tags [i].name.equals (h.tk.name)) {
                h.type = tags [i].val;                
                switch (tags [i].val) {
                    case htelm.H_FORM:
                    case htelm.H_SELECT:
                    case htelm.H_TXTAREA:
                    case htelm.H_TABLEDEF:
                    case htelm.H_TABLE:                    
                    case htelm.H_TBHDR:
                    case htelm.H_TBROW:
                    case htelm.H_TBCELL:
                    case htelm.H_IF: {
                        rv = (h.tk.flags & TK_ISEND) != 0 ? -1 : 1;
                        /* check up to see if the that we're matching
                           the right thing. */
                        if (rv < 0) {
                            if (h.ulink == null) {
                                throw new
                                hparseException ("unbalanced tag "+h.body+
                                                 " at top level",
                                                 cur);
                            }
                            if (h.ulink.type != h.type) {
                                throw new
                                    hparseException ("unbalanced tag "+h.body+
                                                 " s/b "+h.ulink.body,
                                                 cur);
                            }
                        }
                        return rv;
                    }
                    case htelm.H_INPUT: {
                        String p = h.tk.getval ("type");
                        int j;
        
                        if (p != null) {
                            for (j = 0; j < intype.length; j++)
                                if (intype [j].name.equals (p)) {
                                    h.type = intype [j].val;
                                    return 0;
                                }
                        }
                        return 0;
                    }
                    case htelm.H_INC: {
                        hparse p;
                        /* no include? bzzt */
                        if (h.tk.flink == null)
                            return 0;
                        /* include a file at h */
                        try {
                            if (h.tk.flink.name.startsWith ("http:"))
                                cur.addURL (h.tk.flink.name);
                            else
                                cur.addFile (h.tk.flink.name);                        
                        } catch (IOException e) {
                        }
                        return 0;
                    }
                    case htelm.H_SET: {
                        // no include? bzzt
                        if (h.tk.flink == null) {
                            return 0;
                        }
                        hcond.hputenv (h.tk.flink.name,
                                 h.tk.flink.flink != null ?
                                 h.tk.flink.flink.name : "");
                        return 0;
                    }
                    default:
                    return 0;
                }
            }
        }
        return 0;
    }
}






        


