#include "db.h"

hrec *
getdefrec () 
{
    hrec * rv = newhrec ();
    char bf [2];
    
    hradd (rv, "text", "");
    hraddint (rv, "int", 0);
    hradddouble (rv, "double", 0.0);
    hraddbf (rv, "char30", bf, 30);
    hraddbin (rv, "bin", bf, 0);
    return rv;
}


main (int ac, char ** av) 
{
    hrec * r;
    mtccdb * db;
    int rv, i;
    char * key, * txt;
    clause * c;
    
    db = mtccOpenDB ("foo");
    if (ac < 2)
        exit (0);
    switch (av [1][0]) {
        case 'c':
            r = getdefrec ();
            if (mtccCreateDB ("foo", r) == 1)
                printf ("done.\n");
            else
                printf ("error.\n");
            exit (0);
        case 'i':
            key = av [2];
            txt = av [3];
            if (db == 0) {
                printf ("can't open db.\n");
                exit (0);
            }
            r = newhrec ();
            hradd (r, key, txt);
            mtccInsert (db, r);
            break;
        case 'u':
            key = av [2];
            txt = av [3];
            if (db == 0) {
                printf ("can't open db.\n");
                exit (0);
            }
            r = newhrec ();
            hradd (r, key, txt);
            i = mtccUpdate (db, r, null);
            printf ("%d updated\n", i);
            break;
        case 'd':
            i = mtccDelete (db, null);
            printf ("%d deleted.\n", i);
            
            break;
        case 'l':
            r = mtccDefRec (db);
            rv = mtccFirst (db, r, null);
            while (rv != 0) {
                hrdump (r);
                rv = mtccNext  (db, r);
            }
            break;
        case 's':
            key = av [2];
            txt = av [3];
            r = mtccDefRec (db);
            hradd (r, key, txt);
            
            c = mkclause (mkexpr (hrgeth (r, key), E_EQ), null, C_NOP);
            r = mtccDefRec (db);            
            
            rv = mtccSelect(db, r, c);
            while (rv != 0) {
                hrdump (r);
                rv = mtccNext  (db, r);
            }            
            break;
            
        case 'h':
            printf ("version %d flags %x\n", db->m.dbversion, db->m.flags);
            
            printf ("fields %d @%d drecs %d @%d\n", 
                    db->m.nfields,  db->m.fields,
                    db->m.ndrecs, db->m.drecs);
            
            printf ("nidx: %d allocdrecs %d\n", db->nidx, db->ndrecs);
            for (i = 0; i < db->m.ndrecs; i++)
                printf ("loc: %d len: %d\n", db->drecs [i].loc,
                        db->drecs [i].len);
                        
    }
}

            
