#include <stdio.h>
#include <html.h>
#include <time.h>

#ifdef WANTLOGIN

#if LOGINTYPE == 0
#define FETCH(sock,hr,tbl,ctx, q) (hmfetchrowsf (sock, hr, tbl, ctx, q))
#define dberr() fprintf(stderr, "sql err: %s\n", msqlErrMsg);
#endif
#if LOGINTYPE == 1
#define FETCH(sock, hr,tbl,ctx,q) (hdbmfetchrows (hr, ctx, 0, 0))
#define dberr() fprintf(stderr, "dbm err\n");
#endif


void stats (int sock) 
{
    long tm;
    hrec * hr = newloginrec ();
    void * ctx = 0;
    char curfac [256];
    int n = 0, u = 0, a = 0;
    int tn = 0, tu = 0, ta = 0;
    
    
    time (&tm);
    curfac [0] = 0;
    printf ("facility   user                 hits host                           active\n");
    printf ("--------------------------------------------------------------------------\n");
    while (FETCH (sock, hr, LOGINDBTABLE, &ctx, "order by facility,user")) {
        
        if (* curfac && strcmp (curfac, hrget (hr, "facility"))) {
            printf ("--------------------------------------------------------------------------\n");
            printf ("%d users, %d hits, %d active\n", u, n, a);
            n = 0;
            u = 0;
            a = 0;
        }
        printf ("%-10.10s %-20.20s %-4d %-30.30s %s\n",
                hrget (hr, "facility"), hrget (hr, "user"),
                hrgetint (hr, "hits"), hrget (hr, "host"), 
                hrgetint (hr, "timeout") < tm ? "" : "*");
        n += hrgetint (hr, "hits");
        tn += hrgetint (hr, "hits");
        u++;
        tu++;
        if (hrgetint (hr, "timeout") > tm) {
            a++;
            ta++;
        }
        strcpy (curfac, hrget (hr, "facility"));
    }
    printf ("--------------------------------------------------------------------------\n");
    printf ("%d users, %d hits, %d active\n", u, n, a);
    printf ("totals: %d users, %d hits, %d active\n", tu, tn, ta);
}

    


void list (int sock) 
{
    long tm;
    hrec * hr = newloginrec ();            
    void * ctx = 0;
    
    time (&tm);
    
    printf ("facility   user       hits host                           active\n");
    while (FETCH (sock, hr, LOGINDBTABLE, &ctx, "order by facility,user")) {
        printf ("%-10.10s %-10.10s %-4d %-30.30s %s\n",
                hrget (hr, "facility"), hrget (hr, "user"),
                hrgetint (hr, "hits"), hrget (hr, "host"), 
                hrgetint (hr, "timeout") < tm ? "" : "*");
    }
    
}


int main (int ac, char ** av) 
{
    hrec * in;
    char * cmd;
    int rv, sock;
    
    in = hrgetparams (0, ac, av);
    if (* (cmd = hrget (in, "cmd")) == 0) {
        if (ac < 2) {
            fprintf (stderr, "not enough arguments\n");
            exit (1);
        }
        cmd = av [1];
    }

    if ((sock = hinitlogin ("fasolt", "pwd", "zz", 60*60)) < 0) {
        fprintf (stderr, "can't start up login database.");
        exit (1);
    }
    switch (* cmd) {
        case 'p':
            if ((rv = hloginpurge (0)) < 0)
                dberr ();
            printf ("%d records purged.\n", rv);
            break;
        case 'd':
            if ((rv = hloginpurge (1)) < 0)
                dberr ();
            printf ("%d records purged.\n", rv);
            break;
        case 's':
            stats (sock);
            break;
        case 'l':
            list (sock);
            break;
            
        default:
            fprintf (stderr, "unknown command %s\n", cmd);
            exit (1);
    }
    exit (0);
}



#else

int main () 
{
    fprintf (stderr, "You must include the module hlogin.o\n");
    exit (1);
}


            

#endif
