#include <html.h>
#include <crawl.h>

#define GENERIC "/generic.html"

void error (char *, ...);

int curlvl = 0;
hrec * in;
int broken = 0;
URL baseurl;


int list (struct crawlnode * n) {
    if (n->level > curlvl) {
        htprintf ("<ul>");
    }
    if (n->level < curlvl) {
        htprintf ("</ul>");
    }
    htprintf ("<li>");
    aHTML (n->url, 0);
    if (broken) {
        htprintf ("%s (%s)\n", n->url, * n->type ? n->type : "BROKEN LINK");
    } else {
        URL u;
        int len = strlen (baseurl.path);
        
        parseurl (n->url, &u, 0);
        if (curlvl > 0 && ! strcmp (u.host, baseurl.host)) {
            if (! strncmp (u.path, baseurl.path, len)) 
                htprintf ("%s%s\n", u.path+len, u.file);
            else
                htprintf ("%s%s\n", u.path, u.file);
        } else
            htprintf ("%s\n", n->url);
    }
    endaHTML ();
    curlvl = n->level;
    return 1;
}


int main (int ac, char ** av) 
{
    htelm * h;
    int cmd;


    in = newhrec ();
    hradd (in, "template", GENERIC);
    in = hrgetparams (in, ac, av);
    if (hrisvis (in, "-i") == 0)
        preHTML ();
    if (* hrget (in, "url") == 0)
        error ("No file specified.");
    if (* hrget (in, "template") == 0)
        h = htreadurl (GENERIC, 0, 0);
    else
        h = htreadurl (hrget (in, "template"), 0, 0);
    if (h == 0)
        error ("can't open template file.");
    htgotomark ("pagebody");
    cmd = CRL_EXTRAFIRST;
    if (* hrget (in, "broken")) {
        broken++;
        cmd |= CRL_LEAFVISIT;
    }
    parseurl (hrget (in, "url"), &baseurl, 0);
    hcrawl (hrget (in, "url"), cmd, list);
    while (curlvl-- > 0)
        htprintf ("</ul>");
    htdumpfile ();
    return 0;
}




void 
error (char * fmt, ...) 
{
    va_list ap;
    char bf [512];
    htelm * h;

    VA_START (ap, fmt);
    vsprintf (bf, fmt, ap);
    va_end (ap);
    
    hterase ();
    preHTML ();
    if ((h = htreadurl (hrget (in, "template"), 0, 0)) == 0)
        startHTML ("outline", hrget (in, "baseurl"));
    else {
        htgotomark ("title");
        htprintf ("outline error");
    }
    htgotomark ("pageheader");
    par ();
    htprintf ("an error has occurred: %s\n", bf);
    if (h == 0)
        endHTML ();
    else
        htdumpfile ();    
    exit (0);
}

